/* 
 
                  COPYRIGHT NOTICE
 
This material was developed by Christos Faloutsos and King-Ip Lin
at the University of Maryland, College Park, Department of Computer Science.
Permission is granted to copy this software, to redistribute it
on a nonprofit basis, and to use it for any purpose, subject to
the following restrictions and understandings.
 
1. Any copy made of this software must include this copyright notice
in full.
 
2. All materials developed as a consequence of the use of this
software shall duly acknowledge such use, in accordance with the usual
standards of acknowledging credit in academic research.
 
3. The authors have made no warranty or representation that the
operation of this software will be error-free or suitable for any
application, and they are under under no obligation to provide any
services, by way of maintenance, update, or otherwise.  The software
is an experimental prototype offered on an as-is basis.
 
4. Redistribution for profit requires the express, written permission
of the authors.
 
*/

// Author : $Author$
// Date : $Date$
// Id : $Id$
// $Id: define.h,v 1.1 1996/02/19 23:49:43 kilin Exp $ 
/* define.h */

/* define type of vector components */
#define VCOM_TYPE float
#define PRECISION 1e-6

/* define type of nodes */
#define INTERNAL_NODE 1
#define LEAF_NODE 0

/* determine whether to fetch from disk */
#define FROM_DISK 1
#define FROM_MEMORY 0

/* number of dimensions to expand when new ones are needed from the leaf element */
#define DEFAULT_EXPAND_DIM 1

/* number of dimensions to expand initially */
#define DEFAULT_INIT_EXPAND_DIM 1

/* number of anchor points */
#define NUMOFANCHORS 20

/* global definition of certain symbols */

#define LESS_THAN  -1
#define EQU 0 
#define GREATER_THAN  1

/* return value for insert & deletes */
#define NODE_FULL 0
#define NODE_NOT_FULL 1
#define NODE_EMPTY 0
#define NODE_NOT_EMPTY 1
#define NOT_DELETED -1

#define PARENT_OF_LEAF 1

/* result of insertion to be passed back up */
#define REINSERTED -2
#define SPLITTED -1
#define NO_CHANGED_BRANCH 0
#define TWO_CHANGED_BRANCH 2
#define ONE_CHANGED_BRANCH 1

/* code for specific field for statistics */

/* These are integer variables */
#define  READCOUNT		1
#define  WRITECOUNT		2
#define	 LEAFREADCOUNT		3
#define	 LEAFWRITECOUNT		4
#define	 SPLITNODECOUNT		5
#define  SPLITLEAFCOUNT		6
#define  INSERTBRANCHCOUNT	7
#define	 UNFOLDCOUNT		8
#define	 FOLDBACKCOUNT		9
#define  INSERTELEMENTCOUNT	10
#define  TREESIZE 		11
#define  NODECOUNT		12
#define  LEAFCOUNT 		13
#define  WORDDIFFCALCOUNT 	14
#define  REINSERTCOUNT		15

/* These are floating pts */
#define	 TOTALRADIUSRATIO	-1

/* code to determine whether to search for existence or to search for ALL occurence */

/* lsb :- whether print or not */
#define  SEARCHPRINT     1
#define  SEARCHNOPRINT   0

/* second lsb :- whether exist or all */
#define  SEARCHALL       2
#define  SEARCHEXIST     0

/* whether search exact or search appropximate  */
#define  SEARCHEXACT     1
#define  SEARCHAPPROX    2
#define  SEARCHAPPROXSQ  3
#define  SEARCHAPPROXDIST  4

/* code to determine whether to delete one instance or delete ALL occurence  */
#define  DELETEONCE      1
#define  DELETEALL       2


#define True 1
#define TRUE 1
#define False 0
#define FALSE 0
#define max(Dragon,Eagle) ((Dragon) > (Eagle) ? (Dragon) : (Eagle))
#define min(Dragon,Eagle) ((Dragon) < (Eagle) ? (Dragon) : (Eagle))
#define abs(Dragon) ((Dragon) >= 0 ? (Dragon) : (-(Dragon)))
#define SwapInts(Dragon,Eagle) {int ShakingCrane; ShakingCrane = Dragon; Dragon = Eagle; Eagle = ShakingCrane;}
#define SwapFloats(Dragon,Eagle) {float ShakingCrane; ShakingCrane = Dragon; Dragon = Eagle; Eagle = ShakingCrane;}
/* #define PI 3.141592654 */
#define DEGTORAD ((2*PI)/360)
#define RADTODEG (360/(2*PI))
#define INTOCM	2.54
#define CMTOIN	0.39370079
#define MAXINT 0x7fffffff /*  2147483647 */
#define MININT 0x80000000 /* -2147483648 */
#define BitOr |
#define BitAnd &
#define BitNot ~
#define BitEor ^
