/* 
 
                  COPYRIGHT NOTICE
 
This material was developed by Christos Faloutsos and King-Ip Lin
at the University of Maryland, College Park, Department of Computer Science.
Permission is granted to copy this software, to redistribute it
on a nonprofit basis, and to use it for any purpose, subject to
the following restrictions and understandings.
 
1. Any copy made of this software must include this copyright notice
in full.
 
2. All materials developed as a consequence of the use of this
software shall duly acknowledge such use, in accordance with the usual
standards of acknowledging credit in academic research.
 
3. The authors have made no warranty or representation that the
operation of this software will be error-free or suitable for any
application, and they are under under no obligation to provide any
services, by way of maintenance, update, or otherwise.  The software
is an experimental prototype offered on an as-is basis.
 
4. Redistribution for profit requires the express, written permission
of the authors.
 
*/

// Author : $Author$
// Date : $Date$
// Id : $Id$
// $Id: indexpara.h,v 1.1 1996/02/19 23:49:43 kilin Exp $ 
class TVTree;

class TVTree_Para {
    friend ostream& operator<< (ostream&, const TVTree_Para&);
    friend istream& operator>> (istream&, TVTree_Para&);
    friend TVTree;

public :
   TVTree_Para();
   TVTree_Para(const int, const int, const float, const float, const int);
   TVTree_Para(const TVTree_Para&);

   TVTree_Para& operator=(const TVTree_Para&);
   void SetPageSize(int);
   void SetUnfoldDim(int);
   void SetMinFillPercent(float);
   void SetReinsertPercent(float);
   void SetPickTVBranchCompareCount(int);

   int page_size;  // size of a page (unit read/write from disk)
   int unfold_dim; // number of dimensions to unfold each time
   float min_fill_percent; // 0 to 50, minimum fill percentage
   float reinsert_percent; // 0 to 100 - min_fill_percent, percentage of node to be reinserted
   int pickbranch_compare_count; // Number of entry compared for overlap when picking branches
};
