/* 
 
                  COPYRIGHT NOTICE
 
This material was developed by Christos Faloutsos and King-Ip Lin
at the University of Maryland, College Park, Department of Computer Science.
Permission is granted to copy this software, to redistribute it
on a nonprofit basis, and to use it for any purpose, subject to
the following restrictions and understandings.
 
1. Any copy made of this software must include this copyright notice
in full.
 
2. All materials developed as a consequence of the use of this
software shall duly acknowledge such use, in accordance with the usual
standards of acknowledging credit in academic research.
 
3. The authors have made no warranty or representation that the
operation of this software will be error-free or suitable for any
application, and they are under under no obligation to provide any
services, by way of maintenance, update, or otherwise.  The software
is an experimental prototype offered on an as-is basis.
 
4. Redistribution for profit requires the express, written permission
of the authors.
 
*/

// Author : $Author$
// Date : $Date$
// Id : $Id$
class LinkedList;

class LinkedListTVNode {

  friend LinkedList;

public:

  LinkedListTVNode();
  ~LinkedListTVNode();
  Leaf_Element* Get();
  LinkedListTVNode& Put(Leaf_Element*);

private:

  Leaf_Element *ele;
  LinkedListTVNode *next;

};

class LinkedList{

public:
   LinkedList();
   ~LinkedList();

   LinkedListTVNode* Head(); // return first node 
   LinkedListTVNode* Tail(); // return last node 

   LinkedListTVNode* Cur(); // return current node
   LinkedListTVNode* Next(); // advance cur and return

   LinkedList& Append(Leaf_Element*); // append at tail
   LinkedList& InsertHead(Leaf_Element*); // insert as first element
   LinkedListTVNode* RemoveHead(); // return the deleted node 

   LinkedList& ClearList(); // clear the linked list, but DO NOT destroy the char arrays

   LinkedList& ResetToHead(); // let cur points to the first element
   LinkedList& ResetToTail(); // let cur points to the last element
 
   int IsEmpty() const;

   int Count() const;

//   ostream& PrintList(ostream &os, void (*PrintData)(ostream& os, char *iarray));

private:

   LinkedListTVNode *head, *tail, *cur;
   int count;
};

