/* 
 
                  COPYRIGHT NOTICE
 
This material was developed by Christos Faloutsos and King-Ip Lin
at the University of Maryland, College Park, Department of Computer Science.
Permission is granted to copy this software, to redistribute it
on a nonprofit basis, and to use it for any purpose, subject to
the following restrictions and understandings.
 
1. Any copy made of this software must include this copyright notice
in full.
 
2. All materials developed as a consequence of the use of this
software shall duly acknowledge such use, in accordance with the usual
standards of acknowledging credit in academic research.
 
3. The authors have made no warranty or representation that the
operation of this software will be error-free or suitable for any
application, and they are under under no obligation to provide any
services, by way of maintenance, update, or otherwise.  The software
is an experimental prototype offered on an as-is basis.
 
4. Redistribution for profit requires the express, written permission
of the authors.
 
*/

// Author : $Author$
// Date : $Date$
// Id : $Id$
// $Id: data.h,v 1.3 1996/04/18 21:50:24 kilin Exp kilin $ 

// A key class, used for small, critical info about
// the data

#define DEFAULT_DATADIM 3


class DataPoints {

   friend istream& operator>>(istream&, DataPoints&);
   friend istream& operator>>=(istream&, DataPoints&);
   friend ostream& operator<<(ostream&, DataPoints&);
   friend ofstream& operator<(ofstream&, DataPoints&);

public:
   DataPoints();
   DataPoints(char *);  // convert a byte stream to data
			// input format : <name String>|<address String>

   DataPoints(char *, char *);

   DataPoints(const DataPoints&);

   ~DataPoints();

   TVector Initvec(int start, int end);

   int operator[](int);
   int Size() const;
   char* operator()(); // conver data to byte stream

   DataPoints&  operator=(const DataPoints&);


   int operator==(const DataPoints&) const;

   float Distance(const DataPoints&);

   void Initpos();
  
   static int dim;

   String name;
   String address;

   int *position;
   int *value;


//   Vector vec; // cheating, storing the data vector


};

char *ReadData(ifstream&, int&);
void PrintData(ostream& of, char *iarray);
void WriteData(ofstream& of, char *iarray, int size);
VCOM_TYPE GetFeature(int fno, char *iarray);
int Equal(char* arr1, char* arr2);
float Distance(char* arr1, char* arr2);
char *GetKey(char *arr1, int, int&);
void PrintKey(ostream& of, char *iarray);
