/* 
 
                  COPYRIGHT NOTICE
 
This material was developed by Christos Faloutsos and King-Ip Lin
at the University of Maryland, College Park, Department of Computer Science.
Permission is granted to copy this software, to redistribute it
on a nonprofit basis, and to use it for any purpose, subject to
the following restrictions and understandings.
 
1. Any copy made of this software must include this copyright notice
in full.
 
2. All materials developed as a consequence of the use of this
software shall duly acknowledge such use, in accordance with the usual
standards of acknowledging credit in academic research.
 
3. The authors have made no warranty or representation that the
operation of this software will be error-free or suitable for any
application, and they are under under no obligation to provide any
services, by way of maintenance, update, or otherwise.  The software
is an experimental prototype offered on an as-is basis.
 
4. Redistribution for profit requires the express, written permission
of the authors.
 
*/

// Author : $Author$
// Date : $Date$
// Id : $Id$
// $Id: indextest.h,v 1.2 1996/02/21 16:11:30 kilin Exp $ 
const int default_numinput  = 100;
const int default_numsearch  = 100;
const int default_inskip = 0;
const int default_searchskip = 0;
const int default_searchskiphead = 0;
const int default_searchdist = 0;

const int default_pagesize = 1024;
const int default_sig_dim = 2;
const float default_min_fill_percent = 40.0;
const float default_reinsert_percent = 30.0;
const int default_pickbranch_compare_count = 6;

const char default_osfilename[] = "option";

const char default_lifilename[] = "index";
const char default_svfilename[] = "index";

const char default_ifilename[] = "inputdict";
const char default_sfilename[] = "searchdict";

const int phases = 3;

const int default_buffersize = 12;

const int default_disktime = 10;


enum Searchoption {searchexact = 0,
		   searchappdia = 1,
		   searchappsq = 2,
		   searchappdis = 3,
		   searcheditdist = 4,
		   searcheditdistnosub =5};

class TestPara {

public:
  TestPara(); // set default

  // Option file
  int optionfromfile;
  char osfilename[80];

  // Whether to load index
  int loadindex;
  char lifilename[80];

  // Whether to  insert/search
  int performinsert;
  int performsearch;

  // How many input/search data and how are they read 
  int numinput;
  int inskip;
  int numsearch;
  int searchskip;
  int searchskiphead;
  int searchdist;

  // Option for search
  Searchcode searchcode; // search all vs search exist

  Searchoption searchoption; // search exact or search approx

  int searchprint;
  char *searchprintfile;

  // Input and Search file name
  char ifilename[80];
  char sfilename[80];

  // Whether to save index at the end
  int saveindex; 
  char svfilename[80];


  // print option
  int printindex;
  int onedataperline;


  // Misc options
  int checkvalid;

  // TVTree parameter
  TVTree_Para ip;

  // Buffer size
  int buffersize;

  // Disk fetch time
  int disktime;

  // Quick search?
  int quicksearch;
};
